package com.example.wechat

import androidx.compose.runtime.getValue
import androidx.compose.runtime.mutableStateListOf
import androidx.compose.runtime.mutableStateOf
import androidx.compose.runtime.setValue
import androidx.lifecycle.ViewModel
import com.example.wechat.data.Chat
import com.example.wechat.data.Msg
import com.example.wechat.data.User
import com.example.wechat.ui.theme.WeChatTheme

class WeViewModel: ViewModel() {
    var chats by mutableStateOf(
        listOf( // List<Chat>
            Chat(
                friend = User("jskj", "骏升科技", R.drawable.avatar_jskj),
                mutableStateListOf(
                    Msg(User("jskj", "骏升科技", R.drawable.avatar_jskj), "早上好！", "8:20"),
                    Msg(User.Me, "早", "14:21"),
                    Msg(User("jskj", "骏升科技", R.drawable.avatar_jskj), "该吃饭了", "12:00"),
                    Msg(User.Me, "我们去吃饭吧", "12:02"),
                    Msg(User("jskj", "骏升科技", R.drawable.avatar_jskj), "下班了", "18:00"),
                    Msg(User.Me, "拜拜", "18:00"),
                )
            ),
            Chat(
                friend = User("yinzhicheng", "尹志成", R.drawable.avatar_yinzhicheng),
                mutableStateListOf(
                    Msg(User("yinzhicheng", "尹志成", R.drawable.avatar_yinzhicheng), "你好", "8:00"),
                    Msg(User.Me, "Hello！", "8:00"),
                    Msg(User("yinzhicheng", "尹志成", R.drawable.avatar_yinzhicheng), "请用compose写一个简单的微信界面", "12:00").apply { read = false },
                )
            ),
        )
    )
    val contacts by mutableStateOf(
        listOf(
            User("jskj", "骏升科技", R.drawable.avatar_jskj),
            User("yinzhicheng", "尹志成", R.drawable.avatar_yinzhicheng)
        )
    )
    var theme by mutableStateOf(WeChatTheme.Theme.Light)
    var currentChat: Chat? by mutableStateOf(null)
    var chatting by mutableStateOf(false)

    fun startChat(chat: Chat) {
        chatting = true
        currentChat = chat
    }

    fun endChat(): Boolean {
        if (chatting) {
            chatting = false
            return true
        }
        return false
    }

    fun boom(chat: Chat) {
        chat.msgs.add(Msg(User.Me, "\uD83D\uDCA3", "15:10").apply { read = true })
    }
}